SDL_power.c File Reference
`#include "../SDL_internal.h"`
`#include "SDL_power.h"`
`#include "SDL_syspower.h"`
Include dependency graph for SDL_power.c:

Go to the source code of this file.

## Typedefs

typedef SDL_bool(* | SDL_GetPowerInfo_Impl) (SDL_PowerState *state, int *seconds, int *percent)

## Functions

SDL_PowerState | SDL_GetPowerInfo (int *seconds, int *percent)
| Get the current power supply details. More...

## Variables

static SDL_GetPowerInfo_Impl | implementations []

## Typedef Documentation

## SDL_GetPowerInfo_Impl

typedef SDL_bool(* SDL_GetPowerInfo_Impl) (SDL_PowerState *state, int *seconds, int *percent)

Definition at line 30 of file SDL_power.c.

## Function Documentation

## SDL_GetPowerInfo()

SDL_PowerState SDL_GetPowerInfo | ( | int * | secs,
|  | int * | pct
| ) |  |

Get the current power supply details.

Parameters

  secs | Seconds of battery life left. You can pass a NULL here if you don't care. Will return -1 if we can't determine a value, or we're not running on a battery.
  pct | Percentage of battery life left, between 0 and 100. You can pass a NULL here if you don't care. Will return -1 if we can't determine a value, or we're not running on a battery.

Returns
  The state of the battery (if any).

Definition at line 88 of file SDL_power.c.

References i, implementations, NULL, retval, and SDL_POWERSTATE_UNKNOWN.

{
const int total = sizeof(implementations) / sizeof(implementations[0]);
int _seconds, _percent;
SDL_PowerState retval = SDL_POWERSTATE_UNKNOWN;
int i;
/* Make these never NULL for platform-specific implementations. */
if (seconds == NULL) {
seconds = &_seconds;
}
if (percent == NULL) {
percent = &_percent;
}
for (i = 0; i < total; i++) {
if (implementations[i](&retval, seconds, percent)) {
return retval;
}
}
/* nothing was definitive. */
*seconds = -1;
*percent = -1;
return SDL_POWERSTATE_UNKNOWN;
}
SDL_POWERSTATE_UNKNOWN
Definition: SDL_power.h:44
retval
SDL_bool retval
Definition: testgamecontroller.c:65
implementations
static SDL_GetPowerInfo_Impl implementations[]
Definition: SDL_power.c:48
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
SDL_PowerState
SDL_PowerState
The basic state for the system&#39;s power supply.
Definition: SDL_power.h:42

## Variable Documentation

## implementations

SDL_GetPowerInfo_Impl implementations[]

static

Definition at line 48 of file SDL_power.c.

Referenced by SDL_GetPowerInfo().